#!/usr/bin/env python
import os

model_head, fit_tail, ref_tail = 'MODEL_', '.FIT', '.REF'
model_tails = [fit_tail, ref_tail]
sys_data_dir = 'R_code/tis_data'

def getModel(fld, head=model_head, tail=fit_tail, sort=True):
	mdl = (fld and os.path.exists(fld) and os.listdir(fld)) or []
	if not mdl: return mdl
	n1, n2 = len(head), len(tail)
	mdl = filter(lambda a:a.startswith(head) and a.endswith(tail) and len(a)>(n1+n2), mdl)
	if not mdl: return mdl
	#mdl = map(lambda a:(a[n1:-n2], os.path.abspath(os.path.join(fld, a))), mdl)
	if sort:
		mdl.sort(key=str.lower)
	mdl = map(lambda a:(a[n1:-n2], a), mdl)
	return mdl


